
public class Calculator {

	Node<Symbol> erzeugeBeispielBaum() {
	
		Node<Symbol> root = new Node<Symbol>(new Symbol("*"));
		root.left = new Node<Symbol>(new Symbol("3"));
		root.right = new Node<Symbol>(new Symbol("+"));
		root.right.left = new Node<Symbol>(new Symbol("5"));
		root.right.right = new Node<Symbol>(new Symbol("8"));
		
	
		return root;
	}
	
	public int berechne(Node<Symbol> n) {
		if(n.left == null) {
			return n.content.getInt();
		} else {
			int links = berechne(n.left);
			int rechts = berechne(n.right);
			if(n.content.istMal()) {
				return links * rechts;
			} else {
				return links + rechts;
			}
		}
	}
	
	public void infixAusgeben(Node<Symbol> n) {
		//wenn Blatt
		if(n.left == null) {
			System.out.print(n.content);
		} else {
			//links ausgeben
			//wenn aktuell ein * und links ein +, dann mit klammern
			if(n.content.istMal() && n.left.content.istPlus()) {
				System.out.print("(");
				infixAusgeben(n.left);
				System.out.print(")");
			} else {
				infixAusgeben(n.left);
			}
			//Operator ausgeben
			System.out.print(n.content);
			
			//rechts ausgeben
			//wenn aktuell ein * und rechts ein +; dann mit klammern
			if(n.content.istMal() && n.right.content.istPlus()) {
				System.out.print("(");
				infixAusgeben(n.right);
				System.out.print(")");
			} else {
				infixAusgeben(n.right);
			}
			
		}
	}
	
}
